Last Comment Bug 650858 - Instantiating nsICertOverrideService at startup throws NS_ERROR_XPC_GS_RETURNED_FAILURE and makes Firefox unusable
: Instantiating nsICertOverrideService at startup throws NS_ERROR_XPC_GS_RETURN...
Status: RESOLVED FIXED
[may need backout like 5 got]
: regression
Product: Core
Classification: Components
Component: Security: PSM (show other bugs)
: unspecified
: x86 Mac OS X
: -- normal with 5 votes (vote)
: ---
Assigned To: Brian Smith (:briansmith, :bsmith, use NEEDINFO?)
:
Mentors:
Depends on: 679036 679140
Blocks: 619201
  Show dependency treegraph
 
Reported: 2011-04-18 11:00 PDT by chris hofmann
Modified: 2013-12-27 14:23 PST (History)
29 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
+
unaffected
+
unaffected
+
unaffected
+
fixed
-
affected
-
affected


Attachments
last-update.log from this moring (4.49 KB, text/plain)
2011-04-18 15:24 PDT, chris hofmann
no flags Details
Minimal testcase (2.41 KB, application/x-xpinstall)
2011-06-07 15:48 PDT, Jorge Villalobos [:jorgev]
no flags Details
test case for Bug 650858 (2.53 KB, application/x-xpinstall)
2011-07-22 05:24 PDT, foudfou
no flags Details

Description chris hofmann 2011-04-18 11:00:14 PDT
I was running an aurora build from a few days ago.
Got the update offer.
Accepted it, and said ok to restart.

Aurrora restarts, but when it comes back up I get:
 my two app tabs that have no content loads, 
 a new tab that has no content.  
 typing a url in location bar of any of these tabs, or a new tab doesn't respond with loading any content.  
 Quit Aurora kills the window but leaves the process behind.
 need to force quit to kill off the process

restart aurora results in the same problems.

but interestingly I've found that if I start firefox 4.0, quit, then start aurora again, aurora works fine.

I think this basic pattern has happened to me twice now with the last two update offers.
Comment 1 chris hofmann 2011-04-18 12:28:05 PDT
if this is happening to more than just me it would be a serious blocker.
Comment 2 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-18 12:50:40 PDT
Please attach the last-update.log file which is located inside the Mac app bundle in the Contents/MacOS/updates directory.
Comment 3 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-18 13:19:10 PDT
I just updated from the 14th build to the following build without any problems whatsoever. 

Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:5.0a2) Gecko/20110418 Firefox/5.0a2

Also, the fact that your build starts working after switching profiles makes me think it is something with your profile that is causing the problem.

Moving over to General since this doesn't appear to be a toolkit -> app update or Firefox -> installer bug.
Comment 4 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-18 13:19:49 PDT
btw: if you attach the last-update.log I'll double check if there were any problems with the update
Comment 5 chris hofmann 2011-04-18 15:24:05 PDT
Created attachment 526846 [details]
last-update.log from this moring
Comment 6 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-18 15:28:18 PDT
Comment on attachment 526846 [details]
last-update.log from this moring

The update completed successfully without any issues which further leads me to believe this has nothing to do with app update and is likely something to do with the profile.
Comment 7 chris hofmann 2011-04-19 18:54:38 PDT
updated to: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:5.0a2) Gecko/20110419 Firefox/5.0a2 just now and it happened again.

several tabs seemed like they tried to make a network connection to zimbra, gmail, and a few other tabs I had open from previous session, but timed out.  Other tabs showed the url they were trying to load but just a white page.

attempting to reload any of the tabs or load another page got no response.
Comment 8 chris hofmann 2011-04-19 18:59:00 PDT
no diff between contents of the previously posted last-update.log and results returned from this update.

does that non-fatal error show up much?

FINISH REMOVEDIR Contents/MacOS/searchplugins/
non-fatal error removing directory: Contents/MacOS/searchplugins/, rv: 0, err: 66
succeeded
calling QuitProgressUI
Comment 9 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-19 21:08:23 PDT
(In reply to comment #8)
> no diff between contents of the previously posted last-update.log and results
> returned from this update.
> 
> does that non-fatal error show up much?
> 
> FINISH REMOVEDIR Contents/MacOS/searchplugins/
> non-fatal error removing directory: Contents/MacOS/searchplugins/, rv: 0, err:
> 66
> succeeded
> calling QuitProgressUI
Yes and it is a non issue. rmdir instructions are for removing empty directories and the searchplugins directory is not empty. The instruction is in the Firefox removed-files.in file and can be removed but is not a problem. I or someone else will probably remove it as part of bug 649607.
Comment 10 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-19 21:34:24 PDT
Chris, could you try recreating this bug with a new profile without any modifications so we can try to eliminate whether it is something in your profile causing this?
Comment 11 Frédéric Buclin 2011-04-21 09:29:46 PDT
This happened to me too, with Aurora 5.0a2. No idea if that's related, but applying an update makes Aurora to restart and quit immediately (I can barely see the window opening and tabs loading their content, before it quits).
Comment 12 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-21 10:16:31 PDT
(In reply to comment #11)
> This happened to me too, with Aurora 5.0a2. No idea if that's related, but
> applying an update makes Aurora to restart and quit immediately (I can barely
> see the window opening and tabs loading their content, before it quits).
Can you try the steps in comment #10?
Comment 13 Frédéric Buclin 2011-04-21 11:59:12 PDT
Doing a quick test, I couldn't reproduce the problem with a new profile and no plugins and no addons.
Comment 14 chris hofmann 2011-04-21 12:14:05 PDT
found some steps that might help to understand whats going on.

doesn't look like its connected to update at all, but trying to go from an old aurora session, shutting that down, then trying to start aurora again.

on starting that second session rob and I found this message in the error console:

Error: gBrowser.addProgressListener was called with a second argument, which is not supported. See bug 608628.
Source File: chrome://browser/content/tabbrowser.xml
Line: 1840

We also found if we disabled the perspectives addon (ver 4.1) that got rid of the problem and I'm able to go from one aurora session to another smoothly, without having to start up firefox 4 to get aurora started again.

the next step is to figure out if there other addons other than perspectives that might cause this problem, and if the fix needs to come on the addon side, or if there is something that we can do in firefox.
Comment 15 :Gavin Sharp [email: gavin@gavinsharp.com] 2011-04-28 14:57:56 PDT
As Dao mentioned in the other bug, that exception is non-fatal, so it shouldn't be causing any of these symptoms.
Comment 16 Robert Strong [:rstrong] (use needinfo to contact me) 2011-04-28 15:49:28 PDT
Might be something else that this add-on is doing then since everything worked fine after disabling only that one add-on.
Comment 17 Asa Dotzler [:asa] 2011-05-18 12:49:07 PDT
According to https://addons.mozilla.org/en-US/firefox/addon/perspectives/ the Perspectives add-on only has a few tens of thousands of downloads and it's not compatible with Firefox after version 4.0.*  If the problem is limited to that add-on, I think we can safely stop tracking this. We have much larger fish to fry.
Comment 18 Sheila Mooney 2011-05-23 14:51:11 PDT
Dao, can you explain exactly why we don't need to worry about this? Have we figured out exactly why perspectives is breaking?
Comment 19 Daniel Veditz [:dveditz] 2011-05-23 15:00:47 PDT
Perspectives is now marked compatible with Firefox 5.*

I suspect that was auto-bumped, and if it's not true we should revert it back to 4.0.* and be done with it.
Comment 20 Dão Gottwald [:dao] 2011-05-23 15:14:44 PDT
(In reply to comment #18)
> Dao, can you explain exactly why we don't need to worry about this? Have we
> figured out exactly why perspectives is breaking?

Other than ruling out bug 608628, no, and I don't think it's good use of developer time to review random extensions. As things stand, there's no reason to believe that this is a Firefox bug. Someone should notify the add-on developer, who can report back when hitting a bug in our code base.
Comment 21 Dão Gottwald [:dao] 2011-06-02 13:53:59 PDT
(In reply to comment #19)
> Perspectives is now marked compatible with Firefox 5.*
> 
> I suspect that was auto-bumped, and if it's not true we should revert it
> back to 4.0.* and be done with it.

I believe Jorge is the right person for this.
Comment 22 Jorge Villalobos [:jorgev] 2011-06-02 16:54:10 PDT
I did the following:

1) Install Perspectives in Firefox 4.0.1
2) Set up a couple of App Tabs.
3) Close and open the same profile using Aurora.

This didn't trigger the error. However, coincidentally I had an Aurora update in line and installed it. After the restart I did see the problem with the app tabs.

The following errors appeared in the Error Console:

Error: uncaught exception: [Exception... "Component returned failure code: 0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE) [nsIJSCID.getService]"  nsresult: "0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE)"  location: "JS frame :: chrome://perspectives/content/notaries.js :: <TOP_LEVEL> :: line 22"  data: no]

Error: Perspectives is undefined
Source File: chrome://perspectives/content/initialize.xul
Line: 7

Error: uncaught exception: [Exception... "Component returned failure code: 0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE) [nsIJSCID.getService]"  nsresult: "0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE)"  location: "JS frame :: resource:///components/nsUrlClassifierListManager.js :: PROT_ListManager :: line 81"  data: no]

I did this a few times with Beta and Aurora, with the same result. After installing, the first restart (when the add-on is installed) worked ok, but the next restart would trigger the error permanently, until the add-on is removed. The same errors appeared in the console. This doesn't happen in Firefox 4.

Any ideas behind these errors?
Comment 23 Jorge Villalobos [:jorgev] 2011-06-02 17:00:34 PDT
I reverted the compatibility upgrade for the add-on and notified the developer.
Comment 24 Jorge Villalobos [:jorgev] 2011-06-02 17:27:27 PDT
The line in the add-on the first error is pointing to has the following:

overrideService :
  Components.classes["@mozilla.org/security/certoverride;1"]
  .getService(Components.interfaces.nsICertOverrideService)

Trying to instantiate the component on Beta using the Error Console works as expected, so it may be something that only happens at startup.
Comment 25 Dan Wendlandt 2011-06-03 07:25:26 PDT
Hi folks,  I'm one of the developers of Perspectives.  I had actually been running Perspectives fine with one of the previous 5.0 beta downloads that I got directly from the website, but the auto-update I got this morning actually broke things.  I also had a report of this issue from several other users, but until today had been unable to reproduce.  

I am traveling right now, but will try to reproduce or debug over the weekend.  Anyone who has ideas of likely causes, please let me know :)
Comment 26 Asa Dotzler [:asa] 2011-06-06 15:21:34 PDT
no longer tracking for firefox 5
Comment 27 Jorge Villalobos [:jorgev] 2011-06-07 15:48:04 PDT
Created attachment 537889 [details]
Minimal testcase

This bug is a regression in Firefox 5, at least to the extent that it wasn't the case that instantiating certain components at startup could break Firefox entirely. Looking at the commit log for this component, I suspect that this regression is caused by the fixes in bug 645263. That bug touches several components that could also be affected by this.

I'm attaching a minimal testcase. All this add-on does is instantiate the component. The bug is always reproduced in 5, but not in 4. Wrapping the statement in a load event handler fixes the problem. So, instantiating this component throws when the script is being loaded, but not after the window has loaded.

While I expect the occurrence of this bug to be rare, it should still be looked at. It's unclear to me how many components and add-ons are affected by this.
Comment 28 Jorge Villalobos [:jorgev] 2011-06-07 15:51:29 PDT
Moving to XPCOM component.
Comment 29 Benjamin Smedberg [:bsmedberg] 2011-06-08 07:24:52 PDT
What is the regression range, and why do you suspect bug 645263? It looks almost entirely unrelated.
Comment 30 Jorge Villalobos [:jorgev] 2011-06-08 09:10:58 PDT
I don't have a regression range.

This is the log of the implementation file for this component: https://hg.mozilla.org/releases/mozilla-beta/log/tip/security/manager/ssl/src/nsCertOverrideService.cpp. The only recent patches for it are from bug 644070 and bug 645263. Looking at both of them, I noticed the latter was the only one making changes to the constructor, so I thought that was the most likely candidate.
Comment 31 Benjamin Smedberg [:bsmedberg] 2011-06-08 09:16:25 PDT
This doesn't appear to have anything to do directly with the cert override service: we end up calling nsPSMInitPanic::SetPanic in nsNSSComponent::InitializeNSS. More details to come.
Comment 32 christian 2011-06-08 09:25:08 PDT
Benjamin: Is this an unexpected regression? Should we wait on building beta until we know what caused this?
Comment 33 Benjamin Smedberg [:bsmedberg] 2011-06-08 09:30:45 PDT
If this is only triggered by the perspectives addon, then I wouldn't worry about it.
Comment 34 christian 2011-06-08 09:34:21 PDT
I don't think we know that, it's the only one we've heard about but that doesn't mean it's the only on affected.
Comment 35 Benjamin Smedberg [:bsmedberg] 2011-06-08 09:44:55 PDT
 	xul.dll!RealBreak()  Line 413	C++
 	xul.dll!Break(aMsg=0x004ab2b0)  Line 512	C++
 	xul.dll!NS_DebugBreak_P(aSeverity=0x00000001, aStr=0x68c43584, aExpr=0x68c4357c, aFile=0x68c43510, aLine=0x00000678)  Line 380	C++
 	xul.dll!nsComponentManagerImpl::GetServiceByContractID(aContractID=0x68957bb8, aIID={...}, result=0x004ab76c)  Line 1656	C++
 	xul.dll!CallGetService(aContractID=0x68957bb8, aIID={...}, aResult=0x004ab76c)  Line 95	C++
 	xul.dll!nsGetServiceByContractIDWithError::operator()(aIID={...}, aInstancePtr=0x004ab76c)  Line 288	C++
 	xul.dll!nsCOMPtr<nsICertOverrideService>::assign_from_gs_contractid_with_error(gs={...}, aIID={...})  Line 1262	C++
 	xul.dll!nsCOMPtr<nsICertOverrideService>::nsCOMPtr<nsICertOverrideService>(gs={...})  Line 636	C++
>	xul.dll!nsNSSComponent::InitializeNSS(showWarningBox=0x00000001)  Line 1697	C++
 	xul.dll!nsNSSComponent::Init()  Line 1980	C++
 	xul.dll!nsNSSComponentConstructor(aOuter=0x00000000, aIID={...}, aResult=0x004aba1c)  Line 212	C++
 	xul.dll!mozilla::GenericFactory::CreateInstance(aOuter=0x00000000, aIID={...}, aResult=0x004aba1c)  Line 48	C++
 	xul.dll!nsComponentManagerImpl::CreateInstanceByContractID(aContractID=0x68956b64, aDelegate=0x00000000, aIID={...}, aResult=0x004aba1c)  Line 1295	C++
 	xul.dll!nsComponentManagerImpl::GetServiceByContractID(aContractID=0x68956b64, aIID={...}, result=0x004aba74)  Line 1697	C++
 	xul.dll!CallGetService(aContractID=0x68956b64, aIID={...}, aResult=0x004aba74)  Line 95	C++
 	xul.dll!nsGetServiceByContractID::operator()(aIID={...}, aInstancePtr=0x004aba74)  Line 278	C++
 	xul.dll!nsCOMPtr<nsINSSComponent>::assign_from_gs_contractid(gs={...}, aIID={...})  Line 1252	C++
 	xul.dll!nsCOMPtr<nsINSSComponent>::nsCOMPtr<nsINSSComponent>(gs={...})  Line 628	C++
 	xul.dll!EnsureNSSInitialized(op=nssEnsure)  Line 352	C++
 	xul.dll!nsCertOverrideServiceConstructor(aOuter=0x00000000, aIID={...}, aResult=0x004abb94)  Line 250	C++
 	xul.dll!mozilla::GenericFactory::CreateInstance(aOuter=0x00000000, aIID={...}, aResult=0x004abb94)  Line 48	C++
 	xul.dll!nsComponentManagerImpl::CreateInstance(aClass={...}, aDelegate=0x00000000, aIID={...}, aResult=0x004abb94)  Line 1208	C++
 	xul.dll!nsComponentManagerImpl::GetService(aClass={...}, aIID={...}, result=0x004abc04)  Line 1501	C++
 	xul.dll!nsJSCID::GetService(_retval=0x004abccc)  Line 839	C++
 	xul.dll!NS_InvokeByIndex_P(that=0x07dd8148, methodIndex=0x0000000b, paramCount=0x00000001, params=0x004abccc)  Line 103	C++
 	xul.dll!CallMethodHelper::Invoke()  Line 3151	C++
 	xul.dll!CallMethodHelper::Call()  Line 2417	C++
 	xul.dll!XPCWrappedNative::CallMethod(ccx={...}, mode=CALL_METHOD)  Line 2381	C++
 	xul.dll!XPC_WN_CallMethod(cx=0x0792bdb8, argc=0x00000001, vp=0x06c10060)  Line 1607	C++
 	mozjs.dll!js::CallJSNative(cx=0x0792bdb8, native=0x6761ee00, argc=0x00000001, vp=0x06c10060)  Line 277	C++
 	mozjs.dll!js::Interpret(cx=0x0792bdb8, entryFrame=0x06c10030, interpMode=JSINTERP_NORMAL)  Line 4676	C++
 	mozjs.dll!js::RunScript(cx=0x0792bdb8, script=0x07e13c80, fp=0x06c10030)  Line 613	C++
 	mozjs.dll!js::Execute(cx=0x0792bdb8, chain={...}, script=0x07e13c80, prev=0x00000000, flags=0x00000000, result=0x004ad254)  Line 974	C++
 	mozjs.dll!JS_ExecuteScript(cx=0x0792bdb8, obj=0x0769c5b0, scriptObj=0x08597c90, rval=0x004ad254)  Line 4940	C++
 	xul.dll!nsJSContext::ExecuteScript(aScriptObject=0x08597c90, aScopeObject=0x0769c5b0, aRetValue=0x00000000, aIsUndefined=0x00000000)  Line 1612	C++
 	xul.dll!nsXULDocument::ExecuteScript(aContext=0x077d2f60, aScriptObject=0x08597c90)  Line 3641	C++
 	xul.dll!nsXULDocument::ExecuteScript(aScript=0x07e91538)  Line 3664	C++
 	xul.dll!nsXULDocument::ResumeWalk()  Line 3015	C++
 	xul.dll!nsXULDocument::OnPrototypeLoadDone(aResumeWalk=0x00000001)  Line 651	C++
 	xul.dll!nsXULDocument::EndLoad()  Line 635	C++
 	xul.dll!XULContentSinkImpl::DidBuildModel(aTerminated=0x00000000)  Line 278	C++
 	xul.dll!nsParser::DidBuildModel(anErrorCode=0x00000000)  Line 1524	C++
 	xul.dll!nsParser::ResumeParse(allowIteration=0x00000001, aIsFinalChunk=0x00000001, aCanInterrupt=0x00000001)  Line 2269	C++
 	xul.dll!nsParser::OnStopRequest(request=0x07d0ac68, aContext=0x00000000, status=0x00000000)  Line 2852	C++
 	xul.dll!nsJARChannel::OnStopRequest(req=0x07d7e078, ctx=0x00000000, status=0x00000000)  Line 909	C++
 	xul.dll!nsInputStreamPump::OnStateStop()  Line 579	C++
 	xul.dll!nsInputStreamPump::OnInputStreamReady(stream=0x07e13d70)  Line 403	C++
 	xul.dll!nsInputStreamReadyEvent::Run()  Line 115	C++
 	xul.dll!nsThread::ProcessNextEvent(mayWait=0x00000000, result=0x004ad5e0)  Line 618	C++
 	xul.dll!NS_ProcessNextEvent_P(thread=0x006f6290, mayWait=0x00000000)  Line 245	C++
 	xul.dll!mozilla::ipc::MessagePump::Run(aDelegate=0x006fc4c0)  Line 110	C++
 	xul.dll!MessageLoop::RunInternal()  Line 219	C++
 	xul.dll!MessageLoop::RunHandler()  Line 203	C++
 	xul.dll!MessageLoop::Run()  Line 177	C++
 	xul.dll!nsBaseAppShell::Run()  Line 191	C++
 	xul.dll!nsAppShell::Run()  Line 249	C++
 	xul.dll!nsAppStartup::Run()  Line 222	C++
 	xul.dll!XRE_main(argc=0x00000004, argv=0x006e7db0, aAppData=0x006ef960)  Line 3699	C++
 	firefox.exe!NS_internal_main(argc=0x00000004, argv=0x006e7db0)  Line 158	C++

Recursive getservice because the NSS component gets the cert override service.
Comment 36 Benjamin Smedberg [:bsmedberg] 2011-06-08 09:51:36 PDT
This was caused by bug 619201.
Comment 37 Jorge Villalobos [:jorgev] 2011-06-08 10:11:20 PDT
I just did a search in the add-ons MXR for nsICertOverrideService. A couple of add-ons use it, but only Perspectives uses it in the way that produced this bug. Based on comment #33, I think we can remove the tracking flag.
Comment 38 Mark Finkle (:mfinkle) (use needinfo?) 2011-06-08 10:15:42 PDT
Mobile is OK with backing out the patch in bug 619201 to "fix" this
Comment 39 christian 2011-06-08 11:21:01 PDT
We're going to leave bug 619201 in and just live with this for Firefox 5. We're reasonably confident the only affected add-on on AMO is Perspectives and there is a workaround
Comment 40 Johnathan Nightingale [:johnath] 2011-06-13 15:05:07 PDT
Discussed in beta meeting today - and we're concerned that breaking SSL has the potential to break updates or blocklist delivery and so we're going to reverse comment 39 and back out bug 619201. jst has volunteered to handle the backout.
Comment 41 Johnny Stenback (:jst, jst@mozilla.com) 2011-06-13 15:51:22 PDT
Fixed in 5 by backout of bug 619201. Tracking this for 6 since the fix for bug 619201 is still in 6.
Comment 42 David Burns :automatedtester 2011-07-13 09:10:45 PDT
This is currently affecting Selenium WebDriver Browser Automation Framework from working. We need to override the certListener to allow people to test sites that don't have properly signed certificates.

Line in question that is affected is http://code.google.com/p/selenium/source/browse/trunk/javascript/firefox-driver/extension/components/badCertListener.js#87
Comment 43 David Burns :automatedtester 2011-07-14 08:22:23 PDT
I have tested this with the Fx6, Fx7 and Fx8 and all are failing with the same issue. 

This prevents people from checking their sites work with the new versions coming out and is also blocking WebQA, who use Selenium
Comment 44 Asa Dotzler [:asa] 2011-07-14 14:29:27 PDT
Brian, can you help here. We backed out the offending change for 5 and may need to do the same for 6 and 7 if we don't have a solution.
Comment 45 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-07-17 22:57:57 PDT
I think there is likely a simple fix for this. I will write a patch on Monday.
Comment 46 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-07-19 17:44:12 PDT
See bug 619201 comment 8. tl;dr: if backing out the patch for bug 619201 is unproblematic, then lets do that and reopen bug 619201, for which we have two possible alternative solutions that avoid this bug and are otherwise better.
Comment 47 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-07-20 12:33:40 PDT
I am writing a new patch that fixes bug 619201 and avoids causing this one.
Comment 48 foudfou 2011-07-22 05:24:11 PDT
Created attachment 547667 [details]
test case for Bug 650858
Comment 49 foudfou 2011-07-22 05:26:39 PDT
Comment on attachment 547667 [details]
test case for Bug 650858

(In reply to comment #27)
my experience shows that wrapping the nsICertOverrideService instantiation in a load event handler doesn't fix the problem. See test case attachment.
Comment 50 David Burns :automatedtester 2011-07-28 09:10:58 PDT
@Brian

Where are we on getting this patch to review/landed?
Comment 51 christian 2011-08-01 15:01:18 PDT
We'd like to back out bug 619201 for Mozilla-beta. Please do so asap
Comment 52 christian 2011-08-03 17:16:02 PDT
I backed bug 619201 out of beta6:

http://hg.mozilla.org/releases/mozilla-beta/rev/a9bc7596542b

So this bug doesn't affect it anymore. I have not backed it out of aurora or central.
Comment 53 christian 2011-08-11 15:03:32 PDT
Brian, do you have the patch from comment 47? We are probably going to back this out of mozilla-aurora (again). It seems like this should be backed out of mozilla-central as well?
Comment 54 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-08-11 15:19:38 PDT
My original fix used an XPCOM proxy, which will need to be changed since XPCOM proxies are no longer around. I know of an alternate solution and I will have time to have the patch ready for the next Aurora merge, probably Monday.
Comment 55 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-08-15 23:57:09 PDT
This will be fixed when bug 679036 is fixed. With bug 679036, all access to the cert override service is on the main thread.
Comment 56 christian 2011-08-16 00:13:14 PDT
Ok I backed out bug 619201 of aurora7 as well. Should we back out 619201 from mozilla-central and wait for bug 679036 instead (that is, does bug 679036 make 619201 irrelevant?)
Comment 57 David Burns :automatedtester 2011-10-04 04:10:23 PDT
Is there any update on this bug? Selenium WebDriver users would like to start testing their apps and have checked it is failing on Firefox 8+. I have updated the tracking flags
Comment 58 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-10-04 14:21:58 PDT
I will fixup the patch for bug 679140 which just got r+d and check it in tomorrow. That patch will fix this issue.

Long-term, I would like to remove all the socket transport thread <-> main thread synchronization that this fix requires. We can make the built-in implementation of the cert override service thread-safe so that it can be instantiated and used off the main. I don't know if/when this change will be made (not soon), but it seems like a good idea for Selenium developers to prepare a thread-safe version of their implementation of the interface.
Comment 59 Simon Stewart 2011-10-06 17:34:01 PDT
"Their implementation of the interface" being "nsICertOverrideService"?
Comment 60 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-10-11 15:33:40 PDT
(In reply to Simon Stewart from comment #59)
> "Their implementation of the interface" being "nsICertOverrideService"?

Yes. I will reply privately to help you with this.
Comment 61 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-10-11 15:36:07 PDT
There are two ways I can resolve this for Firefox 8: We could either back out bug 619201 like we did previously, or I can apply the patches for bug 679140 to mozilla-beta. Backing out bug 619201 is the least risky.
Comment 62 christian 2011-10-19 12:24:32 PDT
We'd like the backout for beta, thanks!
Comment 63 Brian Smith (:briansmith, :bsmith, use NEEDINFO?) 2011-10-30 22:23:49 PDT
https://hg.mozilla.org/releases/mozilla-beta/rev/dc9713bcaa93
Bug 650858: Back out changeset 999905af7783 (bug 619201). a=backout

The patch for bug 679140 fixes this "permanently."
Comment 64 Mihaela Velimiroviciu (:mihaelav) 2011-11-03 09:04:03 PDT
Verified the backout - bug is still reproducible:

STR:
1. Install Perspectives in Firefox 4.0
2. Opened some pages in new tabs.
3. Close and open the same profile using Firefox 8 beta 5

=>Tabs loaded correctly, but in error console I got:
Error: gBrowser.addProgressListener was called with a second argument, which is not supported. See bug 608628.
Source File: chrome://browser/content/tabbrowser.xml
Line: 1866

4. Restarted Firefox 8
=> Tabs show blank pages instead. In Error console I got:
Error: uncaught exception: [Exception... "Component returned failure code: 0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE) [nsIJSCID.getService]"  nsresult: "0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE)"  location: "JS frame :: chrome://perspectives/content/notaries.js :: <TOP_LEVEL> :: line 41"  data: no]

Error: Perspectives is undefined
Source File: chrome://perspectives/content/initialize.xul
Line: 7

Error: ERROR addons.manager: Exception calling provider getAddonsByTypes: [Exception... "Component returned failure code: 0x80570015 (NS_ERROR_XPC_CI_RETURNED_FAILURE) [nsIJSCID.createInstance]"  nsresult: "0x80570015 (NS_ERROR_XPC_CI_RETURNED_FAILURE)"  location: "JS frame :: resource:///modules/PluginProvider.jsm :: getIDHashForString :: line 32"  data: no]
Source File: resource:///modules/PluginProvider.jsm
Line: 32

Error: uncaught exception: [Exception... "Component returned failure code: 0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE) [nsIJSCID.getService]"  nsresult: "0x80570016 (NS_ERROR_XPC_GS_RETURNED_FAILURE)"  location: "JS frame :: resource:///components/nsUrlClassifierListManager.js :: PROT_ListManager :: line 81"  data: no]
Comment 65 Mihaela Velimiroviciu (:mihaelav) 2011-11-03 10:22:45 PDT
Ignore my previous comment.

Verified the backout on 8 beta build 2 and the bug is not reproducible anymore, behaviour being the same as with Firefox 5.0:
1. Install Perspectives in Firefox 4.0
2. Opened some pages in new tabs.
3. Close and open the same profile using Firefox 8 beta 6
4. Restarted Firefox 8 beta 6
=> All tabs load correctly

Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:8.0) Gecko/20100101 Firefox/8.0

Note You need to log in before you can comment on or make changes to this bug.